Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Prins/Manipulators/PrinsLSManipulator.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Prins/Manipulators/PrinsLSManipulator.cs	(revision 17697)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Prins/Manipulators/PrinsLSManipulator.cs	(revision 17698)
@@ -48,9 +48,9 @@
     }
 
-    protected double GetQuality(PrinsEncoding individual) {
+    protected double GetQuality(PrinsEncodedSolution individual) {
       return ProblemInstance.Evaluate(individual).Quality;
     }
 
-    private int FindCity(PrinsEncoding individual, int city) {
+    private int FindCity(PrinsEncodedSolution individual, int city) {
       int index = -1;
 
@@ -68,5 +68,5 @@
     protected const int depot = -1;
 
-    private Tour FindTour(PrinsEncoding individual, int city) {
+    private Tour FindTour(PrinsEncodedSolution individual, int city) {
       Tour found = null;
 
@@ -85,5 +85,5 @@
 
     //inserts u after v in the child
-    private void InsertAfter(int u, int v, PrinsEncoding parent, PrinsEncoding child) {
+    private void InsertAfter(int u, int v, PrinsEncodedSolution parent, PrinsEncodedSolution child) {
       int pi = 0;
       int ci = 0;
@@ -104,5 +104,5 @@
 
     //inserts (u, x) after v in the child
-    private void InsertAfter(int u, int x, int v, PrinsEncoding parent, PrinsEncoding child) {
+    private void InsertAfter(int u, int x, int v, PrinsEncodedSolution parent, PrinsEncodedSolution child) {
       int pi = 0;
       int ci = 0;
@@ -126,5 +126,5 @@
 
     //inserts u before v in the child
-    private void InsertBefore(int u, int v, PrinsEncoding parent, PrinsEncoding child) {
+    private void InsertBefore(int u, int v, PrinsEncodedSolution parent, PrinsEncodedSolution child) {
       int pi = 0;
       int ci = 0;
@@ -145,5 +145,5 @@
 
     //inserts (u, x) before v in the child
-    private void InsertBefore(int u, int x, int v, PrinsEncoding parent, PrinsEncoding child) {
+    private void InsertBefore(int u, int x, int v, PrinsEncodedSolution parent, PrinsEncodedSolution child) {
       int pi = 0;
       int ci = 0;
@@ -167,5 +167,5 @@
 
     //swaps u and v
-    private void Swap(int u, int v, PrinsEncoding parent, PrinsEncoding child) {
+    private void Swap(int u, int v, PrinsEncodedSolution parent, PrinsEncodedSolution child) {
       for (int i = 0; i < child.Length; i++) {
         if (parent[i] == u)
@@ -179,5 +179,5 @@
 
     //swaps (u, x) and v
-    private void Swap(int u, int x, int v, PrinsEncoding parent, PrinsEncoding child) {
+    private void Swap(int u, int x, int v, PrinsEncodedSolution parent, PrinsEncodedSolution child) {
       int childIndex = 0;
       int parentIndex = 0;
@@ -201,5 +201,5 @@
 
     //swaps (u, x) and (v, y)
-    private void Swap(int u, int x, int v, int y, PrinsEncoding parent, PrinsEncoding child) {
+    private void Swap(int u, int x, int v, int y, PrinsEncodedSolution parent, PrinsEncodedSolution child) {
       int i = 0;
 
@@ -222,5 +222,5 @@
 
     //swaps (u, x) and (v, y) by (u, y) and (x, v)
-    private void Swap2(int u, int x, int v, int y, PrinsEncoding parent, PrinsEncoding child) {
+    private void Swap2(int u, int x, int v, int y, PrinsEncodedSolution parent, PrinsEncodedSolution child) {
       int i = 0;
 
@@ -240,5 +240,5 @@
     }
 
-    private void M1(PrinsEncoding parent, PrinsEncoding child, int u, int v) {
+    private void M1(PrinsEncodedSolution parent, PrinsEncodedSolution child, int u, int v) {
       if (u != depot) {
         if (v == depot) {
@@ -252,5 +252,5 @@
     }
 
-    private void M2(PrinsEncoding parent, PrinsEncoding child, int u, int v) {
+    private void M2(PrinsEncodedSolution parent, PrinsEncodedSolution child, int u, int v) {
       if (u != depot) {
         Tour tour = FindTour(child, u + 1);
@@ -270,5 +270,5 @@
     }
 
-    private void M3(PrinsEncoding parent, PrinsEncoding child, int u, int v) {
+    private void M3(PrinsEncodedSolution parent, PrinsEncodedSolution child, int u, int v) {
       if (u != depot) {
         Tour tour = FindTour(child, u + 1);
@@ -288,5 +288,5 @@
     }
 
-    private void M4(PrinsEncoding parent, PrinsEncoding child, int u, int v) {
+    private void M4(PrinsEncodedSolution parent, PrinsEncodedSolution child, int u, int v) {
       if (u != depot && v != depot) {
         Swap(u, v, parent, child);
@@ -294,5 +294,5 @@
     }
 
-    private void M5(PrinsEncoding parent, PrinsEncoding child, int u, int v) {
+    private void M5(PrinsEncodedSolution parent, PrinsEncodedSolution child, int u, int v) {
       if (u != depot && v != depot) {
         Tour tour = FindTour(child, u + 1);
@@ -307,5 +307,5 @@
     }
 
-    private void M6(PrinsEncoding parent, PrinsEncoding child, int u, int v) {
+    private void M6(PrinsEncodedSolution parent, PrinsEncodedSolution child, int u, int v) {
       if (u != depot && v != depot) {
         Tour tour = FindTour(child, u + 1);
@@ -326,5 +326,5 @@
     }
 
-    private void M7(PrinsEncoding parent, PrinsEncoding child, int u, int v) {
+    private void M7(PrinsEncodedSolution parent, PrinsEncodedSolution child, int u, int v) {
       if (u != depot && v != depot) {
         Tour tu = FindTour(child, u + 1);
@@ -348,5 +348,5 @@
     }
 
-    private void M8(PrinsEncoding parent, PrinsEncoding child, int u, int v) {
+    private void M8(PrinsEncodedSolution parent, PrinsEncodedSolution child, int u, int v) {
       if (u != depot && v != depot) {
         Tour tu = FindTour(child, u + 1);
@@ -370,5 +370,5 @@
     }
 
-    private void M9(PrinsEncoding parent, PrinsEncoding child, int u, int v) {
+    private void M9(PrinsEncodedSolution parent, PrinsEncodedSolution child, int u, int v) {
       if (u != depot && v != depot) {
         Tour tu = FindTour(child, u + 1);
@@ -392,16 +392,16 @@
     }
 
-    protected PrinsEncoding Manipulate(PrinsEncoding individual,
+    protected PrinsEncodedSolution Manipulate(PrinsEncodedSolution individual,
       double originalQuality, int u, int v) {
-      PrinsEncoding child = null;
+      PrinsEncodedSolution child = null;
       bool improvement = false;
 
       if (u != v) {
-        child = individual.Clone() as PrinsEncoding;
+        child = individual.Clone() as PrinsEncodedSolution;
         M1(individual, child, u, v);
         improvement = GetQuality(child) < originalQuality;
 
         if (!improvement) {
-          child = individual.Clone() as PrinsEncoding;
+          child = individual.Clone() as PrinsEncodedSolution;
           M2(individual, child, u, v);
           improvement = GetQuality(child) < originalQuality;
@@ -409,5 +409,5 @@
 
         if (!improvement) {
-          child = individual.Clone() as PrinsEncoding;
+          child = individual.Clone() as PrinsEncodedSolution;
           M3(individual, child, u, v);
           improvement = GetQuality(child) < originalQuality;
@@ -415,5 +415,5 @@
 
         if (!improvement) {
-          child = individual.Clone() as PrinsEncoding;
+          child = individual.Clone() as PrinsEncodedSolution;
           M4(individual, child, u, v);
           improvement = GetQuality(child) < originalQuality;
@@ -421,5 +421,5 @@
 
         if (!improvement) {
-          child = individual.Clone() as PrinsEncoding;
+          child = individual.Clone() as PrinsEncodedSolution;
           M5(individual, child, u, v);
           improvement = GetQuality(child) < originalQuality;
@@ -427,5 +427,5 @@
 
         if (!improvement) {
-          child = individual.Clone() as PrinsEncoding;
+          child = individual.Clone() as PrinsEncodedSolution;
           M6(individual, child, u, v);
           improvement = GetQuality(child) < originalQuality;
@@ -433,5 +433,5 @@
 
         if (!improvement) {
-          child = individual.Clone() as PrinsEncoding;
+          child = individual.Clone() as PrinsEncodedSolution;
           M7(individual, child, u, v);
           improvement = GetQuality(child) < originalQuality;
@@ -439,5 +439,5 @@
 
         if (!improvement) {
-          child = individual.Clone() as PrinsEncoding;
+          child = individual.Clone() as PrinsEncodedSolution;
           M8(individual, child, u, v);
           improvement = GetQuality(child) < originalQuality;
@@ -445,5 +445,5 @@
 
         if (!improvement) {
-          child = individual.Clone() as PrinsEncoding;
+          child = individual.Clone() as PrinsEncodedSolution;
           M9(individual, child, u, v);
           improvement = GetQuality(child) < originalQuality;
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Prins/Manipulators/PrinsManipulator.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Prins/Manipulators/PrinsManipulator.cs	(revision 17697)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Prins/Manipulators/PrinsManipulator.cs	(revision 17698)
@@ -48,13 +48,13 @@
     }
 
-    protected abstract void Manipulate(IRandom random, PrinsEncoding individual);
+    protected abstract void Manipulate(IRandom random, PrinsEncodedSolution individual);
 
     public override IOperation InstrumentedApply() {
-      IVRPEncoding solution = VRPToursParameter.ActualValue;
-      if (!(solution is PrinsEncoding)) {
-        VRPToursParameter.ActualValue = PrinsEncoding.ConvertFrom(solution, ProblemInstance);
+      IVRPEncodedSolution solution = VRPToursParameter.ActualValue;
+      if (!(solution is PrinsEncodedSolution)) {
+        VRPToursParameter.ActualValue = PrinsEncodedSolution.ConvertFrom(solution, ProblemInstance);
       }
 
-      Manipulate(RandomParameter.ActualValue, VRPToursParameter.ActualValue as PrinsEncoding);
+      Manipulate(RandomParameter.ActualValue, VRPToursParameter.ActualValue as PrinsEncodedSolution);
 
       return base.InstrumentedApply();
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Prins/Manipulators/PrinsPermutationManipulator.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Prins/Manipulators/PrinsPermutationManipulator.cs	(revision 17697)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Prins/Manipulators/PrinsPermutationManipulator.cs	(revision 17698)
@@ -50,5 +50,5 @@
     }
 
-    protected override void Manipulate(IRandom random, PrinsEncoding individual) {
+    protected override void Manipulate(IRandom random, PrinsEncodedSolution individual) {
       InnerManipulatorParameter.ActualValue.PermutationParameter.ActualName = VRPToursParameter.ActualName;
 
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Prins/Manipulators/PrinsStochasticLSManipulator.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Prins/Manipulators/PrinsStochasticLSManipulator.cs	(revision 17697)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Prins/Manipulators/PrinsStochasticLSManipulator.cs	(revision 17698)
@@ -51,5 +51,5 @@
     }
 
-    protected override void Manipulate(IRandom random, PrinsEncoding individual) {
+    protected override void Manipulate(IRandom random, PrinsEncodedSolution individual) {
       List<Tour> tours = individual.GetTours();
       bool improvement = false;
@@ -59,5 +59,5 @@
         improvement = false;
         double originalQuality = GetQuality(individual);
-        PrinsEncoding child = null;
+        PrinsEncodedSolution child = null;
 
         int samples = 0;
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Prins/PrinsEncodedSolution.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Prins/PrinsEncodedSolution.cs	(revision 17698)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Prins/PrinsEncodedSolution.cs	(revision 17698)
@@ -0,0 +1,177 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using HEAL.Attic;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.PermutationEncoding;
+using HeuristicLab.Problems.VehicleRouting.Interfaces;
+using HeuristicLab.Problems.VehicleRouting.ProblemInstances;
+
+namespace HeuristicLab.Problems.VehicleRouting.Encodings.Prins {
+  [Item("PrinsEncodedSolution", "Represents a Prins encoded solution of the VRP. It is implemented as described in Prins, C. (2004). A simple and effective evolutionary algorithm for the vehicle routing problem. Computers & Operations Research, 12:1985-2002.")]
+  [StorableType("A0E1EBC1-C0F5-4CD5-9279-1A669C6633CD")]
+  public class PrinsEncodedSolution : General.PermutationEncoding {
+    #region IVRPEncoding Members
+    public override int GetTourIndex(Tour tour) {
+      return 0;
+    }
+
+    public override List<Tour> GetTours() {
+      List<Tour> result = new List<Tour>();
+
+      int cities = ProblemInstance.Cities.Value;
+
+      //Split permutation into vector P
+      int[] P = new int[cities + 1];
+      for (int i = 0; i <= cities; i++)
+        P[i] = -1;
+
+      double[] V = new double[cities + 1];
+      V[0] = 0;
+      for (int i = 1; i <= cities; i++) {
+        V[i] = double.MaxValue;
+      }
+
+      for (int i = 1; i <= cities; i++) {
+        int j = i;
+        Tour tour = new Tour();
+        bool feasible = true;
+
+        do {
+          tour.Stops.Add(this[j - 1] + 1);
+
+          VRPEvaluation eval =
+            ProblemInstance.EvaluateTour(tour, this);
+
+          double cost = eval.Quality;
+          feasible = ProblemInstance.Feasible(eval);
+
+          if (feasible || j == i) {
+            if (V[i - 1] + cost < V[j]) {
+              V[j] = V[i - 1] + cost;
+              P[j] = i - 1;
+            }
+            j++;
+          }
+
+        } while (j <= cities && feasible);
+      }
+
+      //extract VRP solution from vector P
+      int index = 0;
+      int index2 = cities;
+      Tour trip = null;
+      do {
+        index = P[index2];
+        trip = new Tour();
+
+        for (int k = index + 1; k <= index2; k++) {
+          trip.Stops.Add(this[k - 1] + 1);
+        }
+
+        if (trip.Stops.Count > 0)
+          result.Add(trip);
+
+        index2 = index;
+      } while (index != 0);
+
+      //if there are too many vehicles - repair
+      while (result.Count > ProblemInstance.Vehicles.Value) {
+        Tour tour = result[result.Count - 1];
+
+        //find predecessor / successor in permutation
+        int predecessorIndex = Array.IndexOf(this.array, tour.Stops[0] - 1) - 1;
+        if (predecessorIndex >= 0) {
+          int predecessor = this[predecessorIndex] + 1;
+
+          foreach (Tour t in result) {
+            int insertPosition = t.Stops.IndexOf(predecessor) + 1;
+            if (insertPosition != -1) {
+              t.Stops.InsertRange(insertPosition, tour.Stops);
+              break;
+            }
+          }
+        } else {
+          int successorIndex = Array.IndexOf(this.array,
+            tour.Stops[tour.Stops.Count - 1] - 1) + 1;
+          int successor = this[successorIndex] + 1;
+
+          foreach (Tour t in result) {
+            int insertPosition = t.Stops.IndexOf(successor);
+            if (insertPosition != -1) {
+              t.Stops.InsertRange(insertPosition, tour.Stops);
+              break;
+            }
+          }
+        }
+
+        result.Remove(tour);
+      }
+
+      return result;
+    }
+    #endregion
+    public PrinsEncodedSolution(Permutation permutation, IVRPProblemInstance problemInstance)
+      : base(permutation, problemInstance) {
+    }
+
+    [StorableConstructor]
+    protected PrinsEncodedSolution(StorableConstructorFlag _) : base(_) {
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new PrinsEncodedSolution(this, cloner);
+    }
+
+    protected PrinsEncodedSolution(PrinsEncodedSolution original, Cloner cloner)
+      : base(original, cloner) {
+    }
+
+    public static PrinsEncodedSolution ConvertFrom(IVRPEncodedSolution encoding, IVRPProblemInstance problemInstance) {
+      List<Tour> tours = encoding.GetTours();
+      List<int> route = new List<int>();
+
+      foreach (Tour tour in tours) {
+        foreach (int city in tour.Stops)
+          route.Add(city - 1);
+      }
+
+      return new PrinsEncodedSolution(
+        new Permutation(PermutationTypes.RelativeUndirected, route.ToArray()), problemInstance);
+    }
+
+    public static PrinsEncodedSolution ConvertFrom(List<int> routeParam, IVRPProblemInstance problemInstance) {
+      List<int> route = new List<int>(routeParam);
+
+      while (route.Remove(0)) { //remove all delimiters (0)
+      }
+
+      for (int i = 0; i < route.Count; i++)
+        route[i]--;
+
+      return new PrinsEncodedSolution(
+        new Permutation(PermutationTypes.RelativeUndirected, route.ToArray()), problemInstance);
+    }
+  }
+}
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Tour.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Tour.cs	(revision 17697)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Tour.cs	(revision 17698)
@@ -48,5 +48,5 @@
     protected Tour(StorableConstructorFlag _) : base(_) { }
 
-    public double GetTourLength(IVRPProblemInstance instance, IVRPEncoding solution) {
+    public double GetTourLength(IVRPProblemInstance instance, IVRPEncodedSolution solution) {
       double length = 0;
 
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Zhu/Crossovers/ZhuCrossover.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Zhu/Crossovers/ZhuCrossover.cs	(revision 17697)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Zhu/Crossovers/ZhuCrossover.cs	(revision 17698)
@@ -48,13 +48,13 @@
     }
 
-    protected abstract ZhuEncoding Crossover(IRandom random, ZhuEncoding parent1, ZhuEncoding parent2);
+    protected abstract ZhuEncodedSolution Crossover(IRandom random, ZhuEncodedSolution parent1, ZhuEncodedSolution parent2);
 
     public override IOperation InstrumentedApply() {
-      ItemArray<IVRPEncoding> parents = new ItemArray<IVRPEncoding>(ParentsParameter.ActualValue.Length);
+      ItemArray<IVRPEncodedSolution> parents = new ItemArray<IVRPEncodedSolution>(ParentsParameter.ActualValue.Length);
       for (int i = 0; i < ParentsParameter.ActualValue.Length; i++) {
-        IVRPEncoding solution = ParentsParameter.ActualValue[i];
+        IVRPEncodedSolution solution = ParentsParameter.ActualValue[i];
 
-        if (!(solution is ZhuEncoding)) {
-          parents[i] = ZhuEncoding.ConvertFrom(solution, ProblemInstance);
+        if (!(solution is ZhuEncodedSolution)) {
+          parents[i] = ZhuEncodedSolution.ConvertFrom(solution, ProblemInstance);
         } else {
           parents[i] = solution;
@@ -64,5 +64,5 @@
 
       ChildParameter.ActualValue =
-        Crossover(RandomParameter.ActualValue, parents[0] as ZhuEncoding, parents[1] as ZhuEncoding);
+        Crossover(RandomParameter.ActualValue, parents[0] as ZhuEncodedSolution, parents[1] as ZhuEncodedSolution);
 
       return base.InstrumentedApply();
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Zhu/Crossovers/ZhuHeuristicCrossover1.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Zhu/Crossovers/ZhuHeuristicCrossover1.cs	(revision 17697)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Zhu/Crossovers/ZhuHeuristicCrossover1.cs	(revision 17698)
@@ -43,5 +43,5 @@
     }
 
-    private void Swap(ZhuEncoding individual, int city1, int city2) {
+    private void Swap(ZhuEncodedSolution individual, int city1, int city2) {
       int index1 = individual.IndexOf(city1);
       int index2 = individual.IndexOf(city2);
@@ -52,9 +52,9 @@
     }
 
-    protected override ZhuEncoding Crossover(IRandom random, ZhuEncoding parent1, ZhuEncoding parent2) {
-      parent1 = parent1.Clone() as ZhuEncoding;
-      parent2 = parent2.Clone() as ZhuEncoding;
+    protected override ZhuEncodedSolution Crossover(IRandom random, ZhuEncodedSolution parent1, ZhuEncodedSolution parent2) {
+      parent1 = parent1.Clone() as ZhuEncodedSolution;
+      parent2 = parent2.Clone() as ZhuEncodedSolution;
 
-      ZhuEncoding child = parent2.Clone() as ZhuEncoding;
+      ZhuEncodedSolution child = parent2.Clone() as ZhuEncodedSolution;
 
       if (parent1.Length != parent2.Length)
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Zhu/Crossovers/ZhuHeuristicCrossover2.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Zhu/Crossovers/ZhuHeuristicCrossover2.cs	(revision 17697)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Zhu/Crossovers/ZhuHeuristicCrossover2.cs	(revision 17698)
@@ -44,9 +44,9 @@
     }
 
-    protected override ZhuEncoding Crossover(IRandom random, ZhuEncoding parent1, ZhuEncoding parent2) {
+    protected override ZhuEncodedSolution Crossover(IRandom random, ZhuEncodedSolution parent1, ZhuEncodedSolution parent2) {
       List<int> p1 = new List<int>(parent1);
       List<int> p2 = new List<int>(parent2);
 
-      ZhuEncoding child = parent2.Clone() as ZhuEncoding;
+      ZhuEncodedSolution child = parent2.Clone() as ZhuEncodedSolution;
 
       if (parent1.Length != parent2.Length)
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Zhu/Crossovers/ZhuMergeCrossover1.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Zhu/Crossovers/ZhuMergeCrossover1.cs	(revision 17697)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Zhu/Crossovers/ZhuMergeCrossover1.cs	(revision 17698)
@@ -45,5 +45,5 @@
     }
 
-    private void Swap(ZhuEncoding individual, int city1, int city2) {
+    private void Swap(ZhuEncodedSolution individual, int city1, int city2) {
       int index1 = individual.IndexOf(city1);
       int index2 = individual.IndexOf(city2);
@@ -54,9 +54,9 @@
     }
 
-    protected override ZhuEncoding Crossover(IRandom random, ZhuEncoding parent1, ZhuEncoding parent2) {
-      parent1 = parent1.Clone() as ZhuEncoding;
-      parent2 = parent2.Clone() as ZhuEncoding;
+    protected override ZhuEncodedSolution Crossover(IRandom random, ZhuEncodedSolution parent1, ZhuEncodedSolution parent2) {
+      parent1 = parent1.Clone() as ZhuEncodedSolution;
+      parent2 = parent2.Clone() as ZhuEncodedSolution;
 
-      ZhuEncoding child = parent2.Clone() as ZhuEncoding;
+      ZhuEncodedSolution child = parent2.Clone() as ZhuEncodedSolution;
 
       if (parent1.Length != parent2.Length)
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Zhu/Crossovers/ZhuMergeCrossover2.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Zhu/Crossovers/ZhuMergeCrossover2.cs	(revision 17697)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Zhu/Crossovers/ZhuMergeCrossover2.cs	(revision 17698)
@@ -46,9 +46,9 @@
     }
 
-    protected override ZhuEncoding Crossover(IRandom random, ZhuEncoding parent1, ZhuEncoding parent2) {
+    protected override ZhuEncodedSolution Crossover(IRandom random, ZhuEncodedSolution parent1, ZhuEncodedSolution parent2) {
       List<int> p1 = new List<int>(parent1);
       List<int> p2 = new List<int>(parent2);
 
-      ZhuEncoding child = parent2.Clone() as ZhuEncoding;
+      ZhuEncodedSolution child = parent2.Clone() as ZhuEncodedSolution;
 
       if (parent1.Length != parent2.Length)
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Zhu/Crossovers/ZhuPermutationCrossover.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Zhu/Crossovers/ZhuPermutationCrossover.cs	(revision 17697)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Zhu/Crossovers/ZhuPermutationCrossover.cs	(revision 17698)
@@ -50,9 +50,9 @@
     }
 
-    protected override ZhuEncoding Crossover(IRandom random, ZhuEncoding parent1, ZhuEncoding parent2) {
+    protected override ZhuEncodedSolution Crossover(IRandom random, ZhuEncodedSolution parent1, ZhuEncodedSolution parent2) {
       //note - the inner crossover is called here and the result is converted to a prins representation
       //some refactoring should be done here in the future - the crossover operation should be called directly
       if (parent1.Length != parent2.Length)
-        return parent1.Clone() as ZhuEncoding;
+        return parent1.Clone() as ZhuEncodedSolution;
 
       InnerCrossoverParameter.ActualValue.ParentsParameter.ActualName = ParentsParameter.ActualName;
@@ -66,5 +66,5 @@
         ExecutionContext.Scope.Variables.Remove(childName);
 
-        return new ZhuEncoding(permutation, ProblemInstance);
+        return new ZhuEncodedSolution(permutation, ProblemInstance);
       } else
         return null;
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Zhu/Manipulators/ZhuManipulator.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Zhu/Manipulators/ZhuManipulator.cs	(revision 17697)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Zhu/Manipulators/ZhuManipulator.cs	(revision 17698)
@@ -48,13 +48,13 @@
     }
 
-    protected abstract void Manipulate(IRandom random, ZhuEncoding individual);
+    protected abstract void Manipulate(IRandom random, ZhuEncodedSolution individual);
 
     public override IOperation InstrumentedApply() {
-      IVRPEncoding solution = VRPToursParameter.ActualValue;
-      if (!(solution is ZhuEncoding)) {
-        VRPToursParameter.ActualValue = ZhuEncoding.ConvertFrom(solution, ProblemInstance);
+      IVRPEncodedSolution solution = VRPToursParameter.ActualValue;
+      if (!(solution is ZhuEncodedSolution)) {
+        VRPToursParameter.ActualValue = ZhuEncodedSolution.ConvertFrom(solution, ProblemInstance);
       }
 
-      Manipulate(RandomParameter.ActualValue, VRPToursParameter.ActualValue as ZhuEncoding);
+      Manipulate(RandomParameter.ActualValue, VRPToursParameter.ActualValue as ZhuEncodedSolution);
 
       return base.InstrumentedApply();
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Zhu/Manipulators/ZhuPermutationManipulator.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Zhu/Manipulators/ZhuPermutationManipulator.cs	(revision 17697)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Zhu/Manipulators/ZhuPermutationManipulator.cs	(revision 17698)
@@ -50,5 +50,5 @@
     }
 
-    protected override void Manipulate(IRandom random, ZhuEncoding individual) {
+    protected override void Manipulate(IRandom random, ZhuEncodedSolution individual) {
       InnerManipulatorParameter.ActualValue.PermutationParameter.ActualName = VRPToursParameter.ActualName;
 
